import System;
import System.IO;

public class DirectoryCopier {
    public static function ShallowCopy(srcDir:String, destDir:String) : int {
        var curFile:int;
        var Files:String[];
        
        // If Destination exists don't copy
        if ( Directory.Exists(destDir) ) {
            return 0;
        }
        
        // If Source doesn't exist don't copy
        if ( !Directory.Exists(srcDir) ) {
            return 0;
        }
        
        // Create the destination directory
        Directory.CreateDirectory(destDir);
        
        // Get the list of files to copy
        Files = Directory.GetFiles(srcDir);
        for(curFile = 0; curFile < Files.Length; curFile++) {
            // Remove any directory Information
            var file:String = Path.GetFileName(Files[curFile]);
            
            // Append directory information and Copy
            File.Copy(
                Path.Combine(srcDir, file),
                Path.Combine(destDir, file));
        }
        
        return Files.Length;
    }
}

var Args:String[] = Environment.GetCommandLineArgs();
Console.WriteLine(DirectoryCopier.ShallowCopy(Args[1], Args[2]));