import System;
import System.IO;

public class DirectoryCopier {
    // This is our original function
    public static function ShallowCopy(srcDir:String, destDir:String) : int {
        ShallowCopy(srcDir, destDir, true);
    }
    
    // Here is the overload I promised
    public static function ShallowCopy(srcDir:String, destDir:String, createDirectory:Boolean) : int {
        var curFile:int;
        var Files:String[];
        
        // If Destination doesn't exist then ...
        if ( !Directory.Exists(destDir) && createDirectory ) {
            // Create the destination directory
            Directory.CreateDirectory(destDir);
        } else {
            // If directory deosn't exist and we don't
            // createDirectory then we should fail.
            return 0;
        }
        
        // If Source doesn't exist don't copy
        if ( !Directory.Exists(srcDir) ) {
            return 0;
        }
        
        // Get the list of files to copy
        Files = Directory.GetFiles(srcDir);
        for(curFile = 0; curFile < Files.Length; curFile++) {
            // Remove any directory Information
            var file:String = Path.GetFileName(Files[curFile]);
            
            // Append directory information and Copy
            File.Copy(
                Path.Combine(srcDir, file),
                Path.Combine(destDir, file));
        }
        
        return Files.Length;
    }
    
    public static function DeepCopy(srcDir:String, destDir:String) : int {
        var Directories:String[];
        var curDirectory:int;
        var filesCopied:int;
        
        // First we shallow copy
        filesCopied = ShallowCopy(srcDir, destDir, true);
        
        Directories = Directory.GetDirectories(srcDir);
        for(curDirectory = 0; curDirectory < Directories.Length; curDirectory++) {
            // Remove all but target directory
            var directory:String = Path.GetFileName(Directories[curDirectory]);
            filesCopied += ShallowCopy(
                Path.Combine(srcDir, directory),
                Path.Combine(destDir, directory),
                true);
        }
        
        return filesCopied;
    }
}

var Args:String[] = Environment.GetCommandLineArgs();
Console.WriteLine(DirectoryCopier.DeepCopy(Args[1], Args[2]));


