import System;
import System.IO;
import System.Globalization;
import System.Text;

public class FileReaderWriter {
    public static function StreamWriterFile() : void {
        var fs:FileStream = new FileStream("StreamFile.txt", FileMode.Create);
        var sw:StreamWriter = new StreamWriter(fs);

        sw.Write('A'); // Write Character
        sw.Write(Char[](['A', 'B', 'C', 'D', 'E', '\n']));
        sw.Write("Hello World");

        sw.Close();
    }
    
    public static function StreamReaderFile() : void {
        var sr:StreamReader = new StreamReader("StreamFile.txt");
        
        Console.WriteLine(sr.Read());
        Console.WriteLine(sr.ReadLine());
        Console.WriteLine(sr.ReadLine());
        Console.WriteLine();
        
        sr.Close();
    }
    
    public static function BinaryWriterFile() : void {
        var fs:FileStream = new FileStream("BinFile.bin", FileMode.Create);
        var bw:BinaryWriter = new BinaryWriter(fs, Encoding.UTF8);
        
        bw.Write(true); // Boolean
        bw.Write(Byte(128)); // Byte
        bw.Write(Byte[]([128,127,126])); // Byte Array
        bw.Write('A'); // Char
        bw.Write(Char[](['A', 'B', 'C', 'D', 'E'])); // Char Array
        bw.Write(Decimal(1.27643));
        bw.Write(Double(1.27643));
        bw.Write(Int16(21));
        bw.Write(Int32(21));
        bw.Write(Int64(21));
        bw.Write(SByte(21));
        bw.Write(Single(1.27643));
        bw.Write("Hello World");
        bw.Write(UInt16(21));
        bw.Write(UInt32(21));
        bw.Write(UInt64(21));
        
        bw.Close();
    }

    public static function BinaryReaderFile() : void {
        var fs:FileStream = new FileStream("BinFile.bin", FileMode.Open);
        var br:BinaryReader = new BinaryReader(fs, Encoding.UTF8);
        
        Console.WriteLine(br.ReadBoolean());
        Console.WriteLine(br.ReadByte());
        Console.WriteLine(br.ReadBytes(4).toString());
        Console.WriteLine(br.ReadChar());
        Console.WriteLine(br.ReadChars(5).toString());
        Console.WriteLine(br.ReadDecimal());
        Console.WriteLine(br.ReadDouble());
        Console.WriteLine(br.ReadInt16());
        Console.WriteLine(br.ReadInt32());
        Console.WriteLine(br.ReadInt64());
        Console.WriteLine(br.ReadSByte());
        Console.WriteLine(br.ReadSingle());
        Console.WriteLine(br.ReadString());
        Console.WriteLine(br.ReadUInt16());
        Console.WriteLine(br.ReadUInt32());
        Console.WriteLine(br.ReadUInt64());
        Console.WriteLine();
        
        try {
            br.ReadByte();
        } catch(e:EndOfStreamException) {
            Console.WriteLine("We read past the end of the stream");
        }
        
        br.Close();
    }
}

var Args:String[] = Environment.GetCommandLineArgs();

FileReaderWriter.StreamWriterFile();
FileReaderWriter.StreamReaderFile();

FileReaderWriter.BinaryWriterFile();
FileReaderWriter.BinaryReaderFile();
