import System;
import System.Xml;
import System.IO;

public class XmlContent {
    public static function GetXmlFromFile(file:String) : XmlDocument {
        var xDoc:XmlDocument = new XmlDocument();
        xDoc.Load(file);
        return xDoc;
    }

    public static function GetXmlFromStream(file:Stream) : XmlDocument {
        var xDoc:XmlDocument = new XmlDocument();
        xDoc.Load(file);
        return xDoc;
    }

    public static function GetXmlFromTextReader(file:TextReader) : XmlDocument {
        var xDoc:XmlDocument = new XmlDocument();
        xDoc.Load(file);
        return xDoc;
    }

    public static function GetXmlFromXmlTextReader(file:XmlTextReader) : XmlDocument {
        var xDoc:XmlDocument = new XmlDocument();
        xDoc.Load(file);
        return xDoc;
    }

    public static function GetXmlFromString(xml:String) : XmlDocument {
        var xDoc:XmlDocument = new XmlDocument();
        xDoc.LoadXml(xml);
        return xDoc;
    }
}

// Here is just wants the name of the file
var xDoc1:XmlDocument = XmlContent.GetXmlFromFile("11-1.xml");

// Pass it in a FileStream which is derived from Stream
var fs1:FileStream = File.Open("11-1.xml", FileMode.Open)
var xDoc2:XmlDocument = XmlContent.GetXmlFromStream(fs1);
fs1.Close();

// We know that a StreamReader is derived from TextReader.  So this works.
var sr1:StreamReader = new StreamReader("11-1.xml");
var xDoc3:XmlDocument = XmlContent.GetXmlFromTextReader(sr1);
sr1.Close();

// XmlTextReader is derived from XmlReader
var xDoc4:XmlDocument = XmlContent.GetXmlFromXmlTextReader(new XmlTextReader("11-1.xml"));

// Finally the document needs to be read into a string
var sr2:StreamReader = new StreamReader("11-1.xml");
var xml:String = sr2.ReadToEnd();
sr2.Close();

var xDoc5:XmlDocument = XmlContent.GetXmlFromString(xml);