import System;
import System.IO;
import System.Xml;

public class ElementWriter {
    public static function WriteInternalElement(w:XmlTextWriter, type:String, value:String) : void {
        w.WriteStartElement("INTERNAL");

        // Write attributes        
        w.WriteStartAttribute("Type", null);
        w.WriteString(type);
        w.WriteEndAttribute();

        // Write content
        w.WriteString(value);
            
        w.WriteEndElement();
    }
    
    public static function WriteLineElement(w:XmlTextWriter, label:String, type:String) : void {
        w.WriteStartElement("LINE");

        // Write content
        w.WriteStartElement("LABEL");
        w.WriteCData(label);
        w.WriteEndElement();
        
        w.WriteStartElement("TYPE");
        w.WriteString(type);
        w.WriteEndElement();
            
        w.WriteEndElement();
    }
}

var w:XmlTextWriter = new XmlTextWriter("11-6.xml", null);
w.Formatting = Formatting.Indented;

w.WriteStartDocument();

// Write Document Content
w.WriteStartElement("PAGE");

// Write Page Content
ElementWriter.WriteInternalElement(w, "StyleSheet", "Default.css");
ElementWriter.WriteInternalElement(w, "Branch", "Input");
ElementWriter.WriteInternalElement(w, "BaseName", "Commercial");
ElementWriter.WriteInternalElement(w, "RegionTable", "LakeMartin");
ElementWriter.WriteInternalElement(w, "RegionID", "292");

ElementWriter.WriteLineElement(w, "Overview", "Panel");
ElementWriter.WriteLineElement(w, "Property ID", "Display");

w.WriteEndElement();

w.WriteEndDocument();

w.Flush();
w.Close();
