import System;
import System.Collections;

public class CommandLineProcessor {
    public static function ProcessCommandLine(Args:String[], SkipFirst:Boolean) : Hashtable {
        var commands:Hashtable = new Hashtable();
        
        for(var i:int = (SkipFirst) ? 1 : 0; i < Args.Length; i++) {

            var reSimplePlus = /^[\/\-](\w+):/;
            if ( reSimplePlus.test(Args[i]) ) {
                var options:ArrayList = new ArrayList();
                var command:String = RegExp["$1"];
                var optionString:String = RegExp.rightContext;

                var reSimpleMore = /(\w+?)(?:,|$)/g;
                while(reSimpleMore.test(optionString)) {
                    options.Add(RegExp["$1"]);
                }

                commands[command] = options;
                continue;
            }

            var reSimple = /^[\/\-](\w+)/;
            if ( reSimple.test(Args[i]) ) {
                commands[RegExp["$1"]] = true; // Load it with true, its simple
                continue;
            }
            
            Console.WriteLine(Args[i] + " broke through the processor.");
        }
        
        return commands;
    }
    
    public static function PrintCommandLineHash(commands:Hashtable) : void {
        var Key:String;
        var Option:String;
        
        for(Key in commands.Keys) {
            if ( commands[Key] instanceof System.Boolean ) {
                Console.WriteLine(Key + ": " + Boolean(commands[Key]));
            } else {
                var options:ArrayList = ArrayList(commands[Key]);
                Console.WriteLine(Key + ": ");
                for(Option in options) {
                    Console.WriteLine("\t" + Option);
                }
            }
        }
    }
}

var Args:String[] = Environment.GetCommandLineArgs();
var Commands:Hashtable = CommandLineProcessor.ProcessCommandLine(Args, true);
CommandLineProcessor.PrintCommandLineHash(Commands);