import System;
import System.Drawing;
import System.Windows.Forms;

public class BasicForm extends Form {
    private var textInput:System.Windows.Forms.TextBox;
    private var labelDisplay:System.Windows.Forms.Label;
    private var button1:System.Windows.Forms.Button;
    private var totalControls:int;

    public function BasicForm() {
        InitializeComponents();
    }
    
    private function Button1_Click(sender:Object, e:EventArgs) : void {
        this.labelDisplay.Text = "Display: " + this.textInput.Text;
    }
    
    private function InitializeComponents() : void {
        this.Text = "Basic Windows Forms";
        this.Height = 160;
        this.Width = 300;
        this.WindowState = FormWindowState.Normal;
        this.StartPosition = FormStartPosition.CenterScreen;
        
        this.totalControls = 3; // This is used for manual layout
        
        this.textInput = new TextBox();
        this.textInput.Text = "Initial Text";
        this.textInput.Height = (this.ClientSize.Height - ((totalControls+1) * 10)) / totalControls;
        this.textInput.Width = this.ClientSize.Width - 20;
        this.textInput.Left = 10;
        this.textInput.Top = 10;
        
        this.labelDisplay = new Label();
        this.labelDisplay.Text = "Display: " + this.textInput.Text;
        this.labelDisplay.Height = (this.ClientSize.Height - ((totalControls+1) * 10)) / totalControls;
        this.labelDisplay.Width = this.ClientSize.Width - 20;
        this.labelDisplay.Left = 10;
        this.labelDisplay.Top = this.textInput.Top + this.textInput.Height + 10;

        this.button1 = new Button();
        this.button1.Text = "Update Label";
        this.button1.Height = (this.ClientSize.Height - ((totalControls+1) * 10)) / totalControls;
        this.button1.Width = this.ClientSize.Width - 20;
        this.button1.Left = 10;
        this.button1.Top = this.labelDisplay.Top + this.labelDisplay.Height + 10;
        this.button1.add_Click(this.Button1_Click);
        
        this.Controls.Add(this.textInput);
        this.Controls.Add(this.labelDisplay);
        this.Controls.Add(this.button1);
    }
    
    public STAThreadAttribute() static function Main(Args:String[]) : void {
        Application.Run(new BasicForm());
    }
}

BasicForm.Main(Environment.GetCommandLineArgs());