// Title:   Listing 3-10
// Author:  Justin Rogers
//
//
import System;
import System.Text;

BuildString();

function BuildString() {
    var MySB:StringBuilder = new StringBuilder();
    
    // Appending normal text
    MySB.Append("Lets start with this\nLittle bit of text\n\n");
    
    // Appending Formatted text
    MySB.Append("Here we are formatting some numbers\n");

    var MyNumbers:Object[] = [500,50,10];
    MySB.AppendFormat("{0:X}, {1,10}, {2}\n\n", MyNumbers);
    
    // Using the Insert method
    MySB.Insert(0, "This text is getting inserted\n\n");
    
    // Removing some text
    MySB.Insert(0, "This is getting inserted to be removed\n");
    MySB.Remove(0, "This is getting inserted to be removed\n".Length);
    
    // Lets make numbers a bit bigger!
    MySB = MySB.Replace("numbers", "NUMBERS");
    
    // And Finally lets examine the Properties
    MySB.AppendFormat("Capacity:     {0}\n", MySB.Capacity);
    
    // Lets Set a higher capacity
    MySB.Capacity = MySB.MaxCapacity / 100;
    
    MySB.AppendFormat("New Capacity: {0}\n", MySB.Capacity);
    MySB.AppendFormat("Max Capacity: {0}\n", MySB.MaxCapacity);
    MySB.AppendFormat("Length:       {0}\n", MySB.Length);

    var MyChars:Object[]   = [MySB.Chars(0), MySB.Chars(1), MySB.Chars(2)];

    MySB.AppendFormat("Some Chars:   {0} {1} {2}\n", MyChars);
    
    // Notice the use of ToString()!
    Console.WriteLine(MySB.ToString());
}
