// Title:   Listing 3-8
// Author:  Justin Rogers
//
//
import System;

var Searchable:String = "This is our searchable string!";
var CharString:String = "aeiou";

// Demonstrates of the basic IndexOf and LastIndexOf functions
Console.WriteLine(Searchable.IndexOf("is"));
Console.WriteLine(Searchable.LastIndexOf("is"));
Console.WriteLine();

// Using Character Arrays.  Will return vowels
Console.WriteLine(Searchable.IndexOf(CharString.ToCharArray()));
Console.WriteLine(Searchable.LastIndexOf(CharString.ToCharArray()));
Console.WriteLine();

// Advanced indexes for IndexOf and LastIndexOf functions
// These will return the second occurence of the string is from the
// beginning and from the end using the first search for the beginning
// offset of the second search.
Console.WriteLine(Searchable.IndexOf("is", Searchable.IndexOf("is") + 1));
Console.WriteLine(Searchable.LastIndexOf("is", Searchable.LastIndexOf("is") - 1));
Console.WriteLine();

// Set up variables for use with EndsWith and StartsWith
var NonPaddedString:String = "Match me in the beginning and the end.";
var PaddedString:String = "AAAAMatch me in the beginning and the end.AAAA";

Console.WriteLine(PaddedString.StartsWith("Match"));
Console.WriteLine(PaddedString.EndsWith("end."));
Console.WriteLine();

Console.WriteLine(NonPaddedString.StartsWith("Match"));
Console.WriteLine(NonPaddedString.EndsWith("end."));
Console.WriteLine();

// Trim Some variables
var TrimString:String = PaddedString.Trim("A".ToCharArray());
var TrimEndString:String = PaddedString.TrimEnd("A".ToCharArray());
var TrimStartString:String = PaddedString.TrimStart("A".ToCharArray());

Console.WriteLine(TrimString);
Console.WriteLine(TrimEndString);
Console.WriteLine(TrimStartString);
Console.WriteLine();

// Pad Some variables
var PadLeftString:String = NonPaddedString.PadLeft(NonPaddedString.Length + 4, 'A');
var PadRightString:String = NonPaddedString.PadRight(NonPaddedString.Length + 4, 'A');

Console.WriteLine(PadLeftString);
Console.WriteLine(PadRightString);
Console.WriteLine();

// And finally some Substrings
var Substring1:String = PaddedString.Substring(4);
var Substring2:String = PaddedString.Substring(4, PaddedString.Length - 8);

Console.WriteLine(Substring1);
Console.WriteLine(Substring2);
Console.WriteLine();
